import QtQuick 2.2
import QtQuick.Layouts 1.1
import QtQuick.Controls 1.2
import car.pcgui 1.0

ApplicationWindow {
    id: window
    visible: true
    title: "Message Gui"

    toolBar: ToolBar {
        height: 180

        Label {
            id: moduleLabel
            text: "Module: "
            anchors.left: parent.left
            anchors.leftMargin: 10
            anchors.top: parent.top
            anchors.topMargin: 20
        }

        TextField {
            id: moduleSearchBox

            placeholderText: "Search..."
            inputMethodHints: Qt.ImhNoPredictiveText

            anchors.left: moduleLabel.right
            anchors.leftMargin: 10
            anchors.right: parent.right
            anchors.rightMargin: 10
            anchors.verticalCenter: moduleLabel.verticalCenter
        }

        Label {
            id: keyLabel
            text: "Key: "
            anchors.left: moduleLabel.left
            anchors.top: moduleLabel.bottom
            anchors.topMargin: 20
        }

        TextField {
            id: keySearchBox

            placeholderText: "Search..."
            inputMethodHints: Qt.ImhNoPredictiveText

            anchors.left: moduleSearchBox.left
            anchors.right: moduleSearchBox.right
            anchors.verticalCenter: keyLabel.verticalCenter
        }

        CheckBox {
            id: mostRecentCheckBox
            text: "show only most recent values"
            checked: false

            anchors.left: moduleLabel.left
            anchors.top: keyLabel.bottom
            anchors.topMargin: 20
        }

        Label {
            id: statusLabel
            text: "Status:"

            anchors.left: moduleLabel.left
            anchors.top: mostRecentCheckBox.bottom
            anchors.topMargin: 20
        }

        Label {
            id: status
            text: "Disconnected"
            color: "red"

            anchors.left: moduleSearchBox.left
            anchors.top: statusLabel.top
        }
    }

    TableView {
        id: tableView

        frameVisible: false
        sortIndicatorVisible: true

        anchors.fill: parent

        Layout.minimumWidth: 400
        Layout.minimumHeight: 240
        Layout.preferredWidth: 600
        Layout.preferredHeight: 400

        TableViewColumn {
            id: moduleColumn
            title: "Module"
            role: "module"
            movable: false
            resizable: true
            width: tableView.viewport.width / 3
        }

        TableViewColumn {
            id: keyColumn
            title: "Key"
            role: "key"
            movable: false
            resizable: true
            width: tableView.viewport.width / 3
        }

        TableViewColumn {
            id: valueColumn
            title: "Value"
            role: "value"
            movable: false
            resizable: true
            width: tableView.viewport.width / 3
        }

        // model: SortFilterProxyModel {
        //     id: proxyModel
        //     source: sourceModel.count > 0 ? sourceModel : null

        //     sortOrder: tableView.sortIndicatorOrder
        //     sortCaseSensitivity: Qt.CaseInsensitive
        //     sortRole: sourceModel.count > 0 ? tableView.getColumn(tableView.sortIndicatorColumn).role : ""

        //     filterString: moduleSearchBox.text
        //     filterSyntax: SortFilterProxyModel.FixedString
        //     filterCaseSensitivity: Qt.CaseInsensitive
        // }

        model: MessageModel {
            id: messageModel
            messageList: messages
        }
    }
}
