#ifndef MESSAGEMODEL_H
#define MESSAGEMODEL_H

#include <QAbstractListModel>
#include "MessageLib/Message.h"
#include "MessageList.h"

class MessageModel : public QAbstractListModel
{
Q_OBJECT

Q_PROPERTY(MessageList * messageList READ getMessageList WRITE setMessageList)

public:
    explicit MessageModel(QObject * parent = nullptr);

    enum
    {
        ModuleRole = Qt::UserRole,
        KeyRole,
        ValueRole
    };

    int rowCount(const QModelIndex & parent = QModelIndex()) const override;

    QVariant data(const QModelIndex & index, int role = Qt::DisplayRole) const override;

    QHash<int, QByteArray> roleNames() const override;

    MessageList * getMessageList() const noexcept;

    void setMessageList(MessageList * newMessageList);

private:
    MessageList * messageList;
};

#endif // MESSAGEMODEL_H